#if 0
@@@@@@@@@ Found old stream on very first test! @@@@@@@@@@
This flow ...
flow 80c6270, PeerAddrType=1, TransAddrType=17
   Source PeerAddress=0.180.0.2, TransAddress=0
   Dest PeerAddress=0.1.0.1, TransAddress=53
f_s_r(): stream 818cbb8 found, rev chain flow 80a5f30
flow 80a5f30, PeerAddrType=1, TransAddrType=17
   Source PeerAddress=0.1.0.1, TransAddress=0
   Dest PeerAddress=0.180.0.2, TransAddress=53
#endif

struct pkt_key
   k1 = { 0,180,0,2 },
   k2 = { 0,1,0,1 };

int bad_flow(struct pkt *bp)
{
   if (bp->TransAddrType == PT_ICMP) return 0;
   if (memcmp(&bp->Low.PeerAddress.byte, &k1.PeerAddress,
         PEER_ADDR_LEN) == 0 &&
      memcmp(&bp->High.PeerAddress.byte, &k2.PeerAddress,
         PEER_ADDR_LEN) == 0)
      return 1;
   if (memcmp(&bp->High.PeerAddress.byte, &k1.PeerAddress,
         PEER_ADDR_LEN) == 0 &&
      memcmp(&bp->Low.PeerAddress.byte, &k2.PeerAddress,
         PEER_ADDR_LEN) == 0)
      return 1;
   return 0;
   }

void pkt_monitor(struct pkt *bp)
{
#if 0  /* <<<<<<<<<<<<<< */
   int x, r;
   struct rtinf_rec *rip;
   struct flow_key sd_key, ds_key;
   Bit32 sd_hash, ds_hash;
   struct search_result sd_pointers, ds_pointers;
   struct pme_env pme;
   struct flow *f;

   /* printf("pkt_mon(): ");  dump_bp(bp);  /**/

#if PKT_DEBUG
  if (bp->pkt_state != 1) {
    printf("pkt_monitor(1): not got, pbp=%x\n", bp);  fflush(stdout);
    }
#endif

#if defined(DOS)
   if (bp->PeerAddrType == AT_DUMMY) {
      if (++dummypackets == 1000) {
         ++kilodummypackets;  dummypackets = 0;
         }
      ++dummypacketrate;
      }
#endif

   bp->n_flows = 0;
   ntm_semaphore_down("P", &r_rts_sem);

   for (x = running_rts; x != 0; x = rip->next_running_rt) {
      rip = &ri[x-1];

      r = match(1, bp, x,&pme, &bp->Low,&bp->High);
      if (r == MIGNORE)
         continue;  /* Try next rule set */
         /* match() builds search_key from bp */
      else if (r == MFAIL) {  /* S->D Fail */
         r = match(0, bp, x,&pme, &bp->High,&bp->Low);
         if (r != MSUC)
            continue;  /* Ignore or fail */
         else { 
            build_search_key(&ds_hash,&ds_key,
               x,&pme, bp, &bp->High,&bp->Low);
            if ((f = current(&ds_pointers, ds_hash,&ds_key)) != NULL) {
               count(f,MREV,bp);
               }
            else {
               f = create(&ds_pointers, x,&pme, &ds_key, bp);
               if (f == NULL) continue;  /* Coudn't create flow */
               count(f,MREV,bp);
               }
            }
         }
      else {  /* S->D Suc */
         build_search_key(&sd_hash,&sd_key,
            x,&pme, bp, &bp->Low,&bp->High);
         if ((f = current(&sd_pointers, sd_hash,&sd_key)) != NULL) {
            count(f,MFWD,bp);
            }
         else {
            build_search_key(&ds_hash,&ds_key,
               x,&pme, bp, &bp->High,&bp->Low);
            if ((f = current(&ds_pointers, ds_hash,&ds_key)) != NULL) {
               count(f,MREV,bp);
               }
            else {
               f = create(&sd_pointers, x,&pme, &sd_key, bp);
               if (f == NULL) continue;  /* Coudn't create flow */
               count(f,MFWD,bp);
               }
            }
         }
      }

# if MULTI
   ntm_semaphore_up("P", &r_rts_sem);
   if (bp->n_flows != 0) queue_count(bp);
   else {  /* Ignored or didn't match */
#  if PKT_DEBUG
      if (bp->pkt_state == 0) {
         printf("pkt_monitor(2): already free, pbp=%x\n", bp); 
         fflush(stdout);
         }
#  endif
      free_pkt(bp);
      }
# endif
#endif  /* <<<<<<<<<<<<<< */
   }

void new_pkt_monitor(struct stream *sp, struct pkt *p_p)
{
   int x, r;
   struct rtinf_rec *rip;
   struct flow_key sd_key, ds_key;
   Bit32 sd_hash, ds_hash;
   struct search_result sd_pointers, ds_pointers;
   struct pme_env pme;
   struct flow *f;

   /* printf("pkt_mon(): ");  dump_bp(p_p);  /**/

#if PKT_DEBUG
  if (p_p->pkt_state != 1) {
    printf("pkt_monitor(1): not got, pbp=%x\n", p_p);  fflush(stdout);
    }
#endif

#if defined(DOS)
   if (p_p->PeerAddrType == AT_DUMMY) {
      if (++dummypackets == 1000) {
         ++kilodummypackets;  dummypackets = 0;
         }
      ++dummypacketrate;
      }
#endif

   sp->n_flows = 0;
   ntm_semaphore_down("P", &r_rts_sem);

   for (x = running_rts; x != 0; x = rip->next_running_rt) {
      rip = &ri[x-1];

      r = match(1, p_p, x,&pme, &p_p->Low,&p_p->High);
      if (r == MIGNORE)
         continue;  /* Try next rule set */
         /* match() builds search_key from p_p */
      else if (r == MFAIL) {  /* S->D Fail */
         r = match(0, p_p, x,&pme, &p_p->High,&p_p->Low);
         if (r != MSUC)
            continue;  /* Ignore or fail */
         else { 
            build_search_key(&ds_hash,&ds_key,
               x,&pme, p_p, &p_p->High,&p_p->Low);
            if ((f = current(&ds_pointers, ds_hash,&ds_key)) != NULL) {
               count(sp, f,MREV);
               }
            else {
               f = create(&ds_pointers, x,&pme, &ds_key, p_p);
               if (f == NULL) continue;  /* Coudn't create flow */
               count(sp, f,MREV);
               }
            }
         }
      else {  /* S->D Suc */
         build_search_key(&sd_hash,&sd_key,
            x,&pme, p_p, &p_p->Low,&p_p->High);
         if ((f = current(&sd_pointers, sd_hash,&sd_key)) != NULL) {
            count(sp, f,MFWD);
            }
         else {
            build_search_key(&ds_hash,&ds_key,
               x,&pme, p_p, &p_p->High,&p_p->Low);
            if ((f = current(&ds_pointers, ds_hash,&ds_key)) != NULL) {
               count(sp, f,MREV);
               }
            else {
               f = create(&sd_pointers, x,&pme, &sd_key, p_p);
               if (f == NULL) continue;  /* Coudn't create flow */
               count(sp, f,MFWD);
               }
            }
         }
      }

# if MULTI
   ntm_semaphore_up("P", &r_rts_sem);
   if (p_p->n_flows != 0) queue_count(p_p);
   else {  /* Ignored or didn't match */
#  if PKT_DEBUG
      if (p_p->pkt_state == 0) {
         printf("pkt_monitor(2): already free, pbp=%x\n", p_p); 
         fflush(stdout);
         }
#  endif
      free_pkt(p_p);
      }
# endif
   }

void process_pkt(struct pkt *p_p)
{
   struct stream *sp = p_p->sp;
   struct pkt *pbp;
   struct stream_data *sdp;

#if 1 /*^^*/
   printf("p_pkt(): %d, ", p_p->v_t.TransType);
   daddr(p_p->v_t.SrcPeerAddr);  printf(" ");
   daddr(p_p->v_t.DestPeerAddr);  printf(", ");
   dport(p_p->v_t.SrcTransAddr);  printf(" ");
   dport(p_p->v_t.DestTransAddr);  
   printf("\n      sp=%0x, sp->fp=%d,  ", sp, flow_nbr(sp->flowp));
#endif

   if (sp->flowp == NULL) {  /* New stream */   
      if ((pbp = get_pkt()) != NULL) {  /* Got a pkt */
/*???         pkt_from_raw(pbp, p_p);  /* Make a pkt for it */
         pbp->Low.Interface = htons(p_p->if_nbr);
         pbp->High.Interface = 0;
            /* NETFLOW uses Low.Interface for ntm_interface */
         pbp->Low.AdjType = p_p->adj_type;  pbp->High.AdjType = 0;

         rawpkt_monitor(sp, pbp);
         if (sp->n_flows == 1)
            actual_count(sp->flowp = sp->fp[0], sp->flow_order[0], pbp);
         else {
            if (sp->n_flows > 1) log_msg(LOG_WARNING, 0,
               "Stream could belong to two flows, being ignored!");
            sp->flowp = streams_to_ignore_fp;
            }

         if (sp->flowp->stdata == NULL) {
            if ((sp->flowp->stdata = get_st_data())== NULL) {
               log_msg(LOG_WARNING, 0, "No streamdata, stream being ignored!");
               sp->flowp = streams_to_ignore_fp;
               }
            }
printf("+\n");  fflush(stdout);  /*^^*/

         free_pkt(pbp);
         }
      else {
         log_msg(LOG_WARNING, 0, "No pkt, stream being ignored!");
         sp->flowp = streams_to_ignore_fp;
         }
      }
   else {  /* Existing stream */
      actual_count(sp->flowp, sp->flow_order[0] ^ sp->dirn, ppppp);

printf("-\n");  fflush(stdout);  /*^^*/
      }

   mutex_lock("prp", &stream_q_mutex);  /* Re-queue the stream */
   sdp = sp->flowp->stdata;  /* This flow's stream_data */
   if (sdp->sq == NULL) {  /* Add it to tail of queue */
      sdp->sq = sp;  sp->prev_sp = NULL;
      }
   else {
      sdp->sq_tail->next_sp = sp;
      sp->prev_sp = sdp->sq_tail;
      }
   sp->next_sp = NULL;  sdp->sq_tail = sp;
   ++sdp->active_streams;  sp->in_stream_q = 1;
   mutex_unlock("prp", &stream_q_mutex);

   free_rawpkt(p_p);
   }


#define MAXPKTLEN  1526

#if !NF_CISCO_DATA && !LFAP_METER
   /* Front-end calls the following routines to get attrib values */

# if DECNET
int dn_node(Bit8 *dn_addr)
{
   return dn_addr[1]<<8 | dn_addr[0];
   }

#  define dn_area(node) (node >> 10)
#  define dn_host(node) (node & 0x3FF)
# endif

void unpack_dn_node(Bit8 *ap, const Bit8 *dn_addr)
{
   Bit8 dl = dn_addr[1];
   ap[0] = dl >> 2;    /* DECnet area */
   ap[1] = dl & 0x03;  ap[2] = dn_addr[0];  /* DECnet host */
   ap[3] = 0;
   }

void unpack_at_node(Bit8 *ap, const Bit8 *at_net, const Bit8 at_node)
{
   ap[0] = at_net[0];  ap[1] = at_net[1];
   ap[2] = at_node;
   ap[3] = 0;
   }

# define BAD_ADJ    1
# define BAD_PEER   2
# define BAD_TRANS  3

void zero_pkt_fields(int which, struct pkt *p_p)
{
   switch (which) {
   case BAD_ADJ:
      p_p->Low.AdjAddr_ms4 = p_p->High.AdjAddr_ms4 = 0;
      p_p->Low.AdjAddr_ls2 = p_p->High.AdjAddr_ls2 = 0;
      p_p->invalid_addrs |= INV_ADJ;
      break;
   case BAD_PEER:
# if QBYTE_PEER
      p_p->Low.PeerAddress.qbyte = p_p->High.PeerAddress.qbyte = 0;
      p_p->v_t.SrcPeerAddr = p_p->v_t.DestPeerAddr = 0;
# else
      memset(&p_p->Low.PeerAddress.byte,  0, PEER_ADDR_LEN+TRANS_ADDR_LEN);
      memset(&p_p->High.PeerAddress.byte, 0, PEER_ADDR_LEN+TRANS_ADDR_LEN);
      memset(&p_p->v_t.SrcPeerAddr.byte,  0, PEER_ADDR_LEN);
      memset(&p_p->v_t.DestPeerAddr.byte, 0, PEER_ADDR_LEN);
      p_p->v_t.SrcTransAddr = p_p->v_t.DestTransAddr = 0;
# endif
      p_p->invalid_addrs |= INV_PEER;
      break;
   case BAD_TRANS:
      bp_p->Low.TransAddress = p_p->High.TransAddress = 0;
      p_p->v_t.SrcTransAddr = p_p->v_t.DestTransAddr = 0;
      p_p->invalid_addrs |= INV_TRANS;
      break;
      }
   }

# if V6
int find_v6_type(int *prot, int *hx, const Bit8 *p, const int hl)
{
   int nh, nx;

   nh = p[6];  nx = 40;
   for (;;) {
      switch (nh) {
      case PT_6FRAG:  /* Fragment */
      case PT_6ESP:   /* Encapsulating Security Payload (ESP) RFC 2406 */
      case PT_6NONH:  /* No next header */
         *prot = nh;
         return 0;  /* Can't see into this packet */

      case PT_6ICMP:  /* ICMPv6 */
#  if V6_TRACE
         printf("ICMPv6 packet filtered and extracted\n");
#  endif
      default:
         *prot = nh;  *hx = nx;
         return 1;  /* Can see into this one */

      case PT_6HOP:   /* Hop-by-hop options */
      case PT_6ROUT:  /* Routing (Type 0) */
      case PT_6DEST:  /* Destination options */
      case PT_6AH:    /* Authentication (AH) RFC 2402 */
         break;  /* Keep looking */
         }
      if (hl < nx) {
         *prot = -1;  /* Not enough header bytes to get Next Header */
         return 0;
         }
      nh = p[nx];
      nx += (p[nx]+1) * 8;
      }
   }
# endif

int pkt_extract(struct pkt *p_p,
   const int type, const Bit8 *hdrp, const int hl)
{
   int prot, dtype, dx, j;
   union decnet *dp;
# if DECNET
   int dlen, snode, dnode, area, host;
# endif
# if NF_OCX_BGP
   Subnet *my_subnet;
   Bit32 my_IP4addr;
   Bit16 my_ASN;
# endif
# if V6_TRACE
   char sa[IP6_ADDR_LEN*4], da[IP6_ADDR_LEN*4];

   if (type == AT_IP6) printf(" Ipv6 packet extracted: \n");
/*   else if (type == AT_IP4) printf(" Ipv4 packet extracted:\n"); /**/
# endif
   p_p->PeerAddrType = type;
   p_p->invalid_addrs = 0;

   switch (type) {
# if V6
   case AT_IP6:  /* RFC 2460 is 'IPv6 Specification' */
#  if !STREAM_ATRS_ONLY
      p_p->DSCodePoint = (ntohs(*(Bit16 *)&hdrp[0]) & 0x0FC0) >> 6;
      p_p->ECNCodeBits = (hdrp[1] & 0x30) >> 4;
#  endif
      if (hl < 8+IP6_ADDR_LEN*2) {  /* Didn't get the peer addresses! */
         zero_pkt_fields(BAD_PEER, p_p);  return 0;
         }
      memcpy(&p_p->Low.PeerAddress, &hdrp[8], IP6_ADDR_LEN);  /* IPv6 source */
      memcpy(&p_p->High.PeerAddress,&hdrp[24],IP6_ADDR_LEN);  /* IPv6 dest */
      memcpy(&p_p->v_t.SrcPeerAddr, &hdrp[8], IP6_ADDR_LEN);
      memcpy(&p_p->v_t.DestPeerAddr,&hdrp[24],IP6_ADDR_LEN);
# if V6_TRACE
      sfmt_v6addr(sa,(Bit8 *)&p_p->Low.PeerAddress);
      sfmt_v6addr(da,(Bit8 *)&p_p->High.PeerAddress);
      printf("   %s -> %s\n", sa,da);
# endif
      if (!find_v6_type(&prot,&dx, hdrp,hl)) {
         if (prot < 0)  /* Not enough bytes to determine protocol */
            p_p->TransAddrType = 0;
         else  /* Can't see into packet body */
            p_p->TransAddrType = prot;
         zero_pkt_fields(BAD_TRANS, p_p);
         return 0;
         }

      switch (p_p->TransAddrType = prot) {
      case PT_UDP:
      case PT_TCP:
         if (hl < dx+4) {  /* Didn't get the IP ports! */
            zero_pkt_fields(BAD_TRANS, p_p);  return 0;
            }
         p_p->v_t.SrcTransAddr  =  p_p->Low.TransAddress =
            *(Bit16 *)&hdrp[dx];    /* Source port */
         p_p->v_t.DestTransAddr =  p_p->High.TransAddress =
            *(Bit16 *)&hdrp[dx+2];  /* Dest port */
         /* In **network** order within Bit16, to match rule values */
         break;
      case PT_6ICMP:  /* RFC 2463 */
      case PT_ICMP:
         if (hl < dx+2) {  /* Didn't get the type,code fields */
            zero_pkt_fields(BAD_TRANS, p_p);  return 0;
            }
         p_p->Low.TransAddress = htons(hdrp[dx]);  /* Type field */
         p_p->High.TransAddress = htons(hdrp[dx+1]);  /* Code field */
         p_p->v_t.SrcTransAddr = p_p->v_t.DestTransAddr = 0;
         break;
         }
# if NEW_ATR && !STREAM_ATRS_ONLY
      if (prot == PT_TCP) {
         if (hl < dx+4+sizeof(p_p->pi.tcp.th)) {  /* Didn't get tcp header */
            p_p->pi.tcp.tcp_len = 0;
            memset(&p_p->pi.tcp.th, 0, sizeof(p_p->pi.tcp.th));
            p_p->pktinfo_sz = 0;
            }
         else {
            memcpy(&p_p->pi.tcp.th, &hdrp[dx+4],
               p_p->pktinfo_sz = sizeof(p_p->pi.tcp.th));
            p_p->pi.tcp.tcp_len = ntohs(*(Bit16 *)&hdrp[2]) - dx;
            }
         }
# endif
      return 1;
   case AT_IP4:
# if !STREAM_ATRS_ONLY
      p_p->DSCodePoint = hdrp[1] >> 2;  /* Old TOS field, RFC 2474 */
      p_p->ECNCodeBits = hdrp[1] && 0x03;  /* RFC 3168, ECN for IP */
# endif
      if (hl < 12+IP4_ADDR_LEN*2) {  /* Didn't get the peer addresses! */
         zero_pkt_fields(BAD_PEER, p_p);
         return 0;
         }
      prot = p_p->TransAddrType = hdrp[9];  /* IPv4 Protocol Type */
      rp->v_t.TransType = prot;
# if QBYTE_PEER
      rp->v_t.SrcPeerAddr = p_p->Low.PeerAddress.qbyte =
         *(Bit32 *)&hdrp[12];  /* IPv4 source */
      rp->v_t.DestPeerAddr = p_p->High.PeerAddress.qbyte =
         *(Bit32 *)&hdrp[16];  /* IPv4 dest */
# else
      memcpy(&p_p->Low.PeerAddress,&hdrp[12],IP4_ADDR_LEN);  /* IPv4 source */
      memcpy(&p_p->High.PeerAddress,&hdrp[16],IP4_ADDR_LEN);  /* IPv4 dest */
      memcpy(&rp->v_t.SrcPeerAddr,&hdrp[12],IP4_ADDR_LEN);
      memcpy(&rp->v_t.DestPeerAddr,&hdrp[16],IP4_ADDR_LEN);
# endif
      if (ntohs(*(Bit16 *)&hdrp[6]) & 0x1FFF != 0) {  /* Frag offset != 0 */
         zero_pkt_fields(BAD_TRANS, p_p);  /* Can't see into fragment */
         return 0;
         }
      dx = (hdrp[0] & 0x0F) << 2;  /* HLEN */
      /* Data offset.  HLEN = IPv4 header length in 32-bit units */
      if (prot == PT_ICMP) {
         if (hl < dx+2) {  /* Didn't get the type,code fields */
            zero_pkt_fields(BAD_TRANS, p_p);
            return 0;
            }
         p_p->Low.TransAddress = htons(hdrp[dx]);  /* Type field */
         p_p->High.TransAddress = htons(hdrp[dx+1]);  /* Code field */
         p_p->v_t.SrcTransAddr = p_p->v_t.DestTransAddr = 0;
         }
      else {
         if (hl < dx+4) {  /* Didn't get the IP ports! */
            zero_pkt_fields(BAD_TRANS, p_p);
            return 0;
            }
         p_p->v_t.SrcTransAddr = p_p->Low.TransAddress =
            *(Bit16 *)&hdrp[dx];  /* Source port */
         p_p->v_t.DestTransAddr = p_p->High.TransAddress =
            *(Bit16 *)&hdrp[dx+2];  /* Dest port */
         /* In **network** order within Bit16, to match rule values */
         }

      if (prot == PT_UDP) {
         if (hl < dx+8+sizeof(p_p->pi.udp.dns)) {  /* Only do dns for now */
            /* Didn't get enough UDP data */
            memset(&p_p->pi.udp, 0, sizeof(p_p->pi.udp));
            p_p->pktinfo_sz = 0;
            }
         else {
            memcpy(&p_p->pi.udp, &hdrp[dx+8],
               p_p->pktinfo_sz = sizeof(p_p->pi.udp));
            }
#  if PP_DEBUG_XX >= 2
   printf("\npkt_extract(2) UDP pkt: info_sz=%d, ",  p_p->pktinfo_sz);
   for (j = 0; j != p_p->pktinfo_sz; ++j) printf(" %02x", ((char *)&p_p->pi.udp)[j]);
   printf("\n");
#  endif
         }

# if NEW_ATR && !STREAM_ATRS_ONLY
#  if OAM
      p_p->ip_id = *(Bit16 *)&hdrp[4];  /* IPv4 identification */
      p_p->High.PeerAddress.qbyte = *(Bit32 *)&hdrp[16];  /* IPv4 dest */
#  endif
      if (prot == PT_TCP) {
         if (hl < dx+4+sizeof(p_p->pi.tcp.th)) {  /* Didn't get tcp header */
            p_p->pi.tcp.tcp_len = 0;
            memset(&p_p->pi.tcp.th, 0, sizeof(p_p->pi.tcp.th));
            p_p->pktinfo_sz = 0;
            }
         else {
            memcpy(&p_p->pi.tcp.th, &hdrp[dx+4],
               p_p->pktinfo_sz = sizeof(p_p->pi.tcp.th));
            p_p->pi.tcp.tcp_len = (hdrp[2] << 8 | hdrp[3]) - dx;
	    }
         }
      else if (prot == PT_ICMP) {
         if (hl < dx+4+sizeof(p_p->pi.icmp)) {  /* Not enough ICMP data */
            zero_pkt_fields(BAD_TRANS, p_p);
            memset(&p_p->pi.icmp, 0, sizeof(p_p->pi.icmp));
            p_p->pktinfo_sz = 0;
            }
         else {
            memcpy(&p_p->pi.icmp, &hdrp[dx+4],
               p_p->pktinfo_sz = sizeof(p_p->pi.icmp));
            }
         }

#  if NF_OCX_BGP
      if (asn_lookup) {
         my_IP4addr = ntohl(p_p->Low.PeerAddress);
         if ((my_subnet = FindSubnet(ntohl(my_IP4addr))) != NULL) {
            my_ASN = use_owner_asns ? my_subnet->src_as : my_subnet->exit_as;
            p_p->Low.nf_ASN[0] = my_ASN >> 8;
            p_p->Low.nf_ASN[1] = my_ASN & 0xff;
            p_p->Low.nf_mask = bits_in_mask(my_subnet->mask);
            }
         else p_p->Low.nf_ASN[0] = p_p->Low.nf_ASN[1] = 0;
         my_IP4addr = ntohl(p_p->High.PeerAddress);
         if ((my_subnet = FindSubnet(ntohl(my_IP4addr))) != NULL) {
            my_ASN = use_owner_asns ? my_subnet->src_as : my_subnet->exit_as;
            p_p->High.nf_ASN[0] = my_ASN >> 8;
            p_p->High.nf_ASN[1] = my_ASN & 0xff;
            p_p->High.nf_mask = bits_in_mask(my_subnet->mask);
            }
         else p_p->High.nf_ASN[0] = p_p->High.nf_ASN[1] = 0;
         }
#  endif
# endif  /* !STREAM_ATRS_ONLY */
      return 1;
   case AT_NOVELL:
      p_p->TransAddrType = hdrp[5];  /* XNS packet type */
      if (hl < 18+IPX_ADDR_LEN) {  /* Didn't get the peer addresses! */
         zero_pkt_fields(BAD_PEER, p_p);
         return 0;
         }
      memcpy(&p_p->High.PeerAddress,&hdrp[6],IPX_ADDR_LEN);  /* IPX dest net */
      memcpy(&p_p->Low.PeerAddress,&hdrp[18],IPX_ADDR_LEN);  /* IPX soure net */
      if (hl < 30) {  /* Didn't get the IPX sockets! */
         zero_pkt_fields(BAD_TRANS, p_p);
         return 0;
         }
      p_p->High.TransAddress = *(Bit16 *)&hdrp[16];
         /* IPX dest socket */
      p_p->Low.TransAddress = *(Bit16 *)&hdrp[28];
         /* IPX source socket */
      return 1;
   case AT_ETHERTALK:
      if (hl < 10) {  /* Didn't get the peer addresses! */
         zero_pkt_fields(BAD_PEER, p_p);
         return 0;
         }
      unpack_at_node(&p_p->Low.PeerAddress.byte, &hdrp[6],hdrp[9]);  /* AT source */
      unpack_at_node(&p_p->High.PeerAddress.byte, &hdrp[4],hdrp[8]);  /* AT source */
      if (hl < 13) {  /* Didn't get the AT sockets! */
         zero_pkt_fields(BAD_TRANS, p_p);
         return 0;
         }
      p_p->TransAddrType =hdrp[12];  /* AT DDP protocol type */
      p_p->Low.TransAddress = (Bit16)hdrp[11];  /* AT source socket */
      p_p->High.TransAddress = (Bit16)hdrp[10];  /* AT dest socket */
      return 1;
   case AT_CLNS:
      p_p->TransAddrType = hdrp[5] & 0x1F;  /* CLNS packet type */
      p_p->Low.TransAddress = p_p->High.TransAddress = 0;
      memcpy(&p_p->High.PeerAddress,&hdrp[11],j = hdrp[10]);  /* Dest */
      if (j < NSAP_ADDR_LEN)
         memset(&p_p->High.PeerAddress + j, 0, NSAP_ADDR_LEN-j);
      memcpy(&p_p->Low.PeerAddress,&hdrp[12+j],dx = hdrp[11+j]);  /* Source */
      if (dx < NSAP_ADDR_LEN)
         memset(&p_p->Low.PeerAddress + dx, 0, NSAP_ADDR_LEN-dx);
      return 1;
   case AT_DECNET:
      p_p->Low.TransAddress = p_p->High.TransAddress = 0;
      dtype = hdrp[2];  /* DECnet packet type */
      if (dtype != 0x81) dp = (union decnet *)&hdrp[3];
      else {
         dtype = hdrp[3];
         dp = (union decnet *)&hdrp[4];
         }
      switch (p_p->TransAddrType = dtype & 0x0F) {
      case 0x06:  /* Data */
      case 0x0E:  /* Data + discard flag */
         unpack_dn_node(&p_p->Low.PeerAddress.byte, dp->d.src_dn_addr);
         unpack_dn_node(&p_p->High.PeerAddress.byte, dp->d.dest_dn_addr);
# if DECNET
         dnode = dn_node(dp->d.dest_dn_addr);
         snode = dn_node(dp->d.src_dn_addr);
         fprintf(logfl,"Data to %d.%d from %d.%d\n",
            dn_area(dnode),dn_host(dnode),
            dn_area(snode),dn_host(snode) );
# endif
         break;
      case 0x07:  /* Level 1 routing */
         unpack_dn_node(&p_p->Low.PeerAddress.byte, dp->l1r.src_dn_addr);
# if DECNET
         snode = dn_node(dp->l1r.src_dn_addr);
         fprintf(logfl,"Level 1 routing from %d.%d\n",
            dn_area(snode),dn_host(snode));
# endif
         break;
      case 0x09:  /* Level 2 routing */
         unpack_dn_node(&p_p->Low.PeerAddress.byte, dp->l2r.src_dn_addr);
# if DECNET
         snode = dn_node(dp->l2r.src_dn_addr);
         fprintf(logfl,"Level 2 routing from %d.%d\n",
            dn_area(snode),dn_host(snode));
# endif
         break;
      case 0x0B:  /* Router hello */
         unpack_dn_node(&p_p->Low.PeerAddress.byte, dp->rh.src_dn_addr);
# if DECNET
         snode = dn_node(dp->rh.src_dn_addr);
         dnode = dn_node(dp->rh.rtr_dn_addr);
         fprintf(logfl,"Router hello from %d.%d, other router %d.%d\n",
            dn_area(snode),dn_host(snode),
            dn_area(dnode),dn_host(dnode) );
# endif
         break;
      case 0x0D:  /* Endnode hello */
         unpack_dn_node(&p_p->Low.PeerAddress.byte, dp->eh.src_dn_addr);
# if DECNET
         snode = dn_node(dp->eh.src_dn_addr);
         dnode = dn_node(dp->eh.rtr_dn_addr);
         fprintf(logfl,"Endnode hello from %d.%d, designated router %d.%d\n",
            dn_area(snode),dn_host(snode),
            dn_area(dnode),dn_host(dnode) );
# endif
         break;
      default:  /* Unknown DECnet type */
         scpos(0,scr_lrow);
         printf("\nDN pkt type %02x: ", dtype);
         for (j=0; j != 16; ++j) printf(" %02x",hdrp[j]);
         printf("\n");
         for (j=16; j != 34; ++j) printf(" %02x",hdrp[j]);
         printf("\n");
# ifdef TESTING
         if (!logfl) open_log();
         fprintf(logfl, "\nDN pkt type %02x: ", dtype);
         for (j=17; j != 34; ++j) fprintf(logfl," %02x",hdrp[j]);
         fprintf(logfl, "\n");
# endif
         }
      return 0;
      }
   return 0;
   }

# if SELECT_TEST
int extract_IP4(struct pkt *p_p, 
   const Bit8 *hdrp, const int hl)
{
   int prot, dtype, dx, j;
   union decnet *dp;

   p_p->PeerAddrType = AT_IP4;
   p_p->invalid_addrs = 0;
   if (hl < 0) {  /* Didn't get the header! */
      zero_pkt_fields(BAD_ADJ, p_p);
      return 0;
      }

   p_p->DSCodePoint = hdrp[1] >> 2;  /* Old TOS field, RFC 2474 */
   p_p->ECNCodeBits = hdrp[1] && 0x03;
   if (hl < 12+IP4_ADDR_LEN*2) {  /* Didn't get the peer addresses! */
      zero_pkt_fields(BAD_PEER, p_p);
      return 0;
      }
#  if QBYTE_PEER
   p_p->Low.PeerAddress.qbyte = *(Bit32 *)&hdrp[12];  /* IPv4 source */
   p_p->High.PeerAddress.qbyte = *(Bit32 *)&hdrp[16];  /* IPv4 dest */
#  else
   memcpy(&p_p->Low.PeerAddress,&hdrp[12],IP4_ADDR_LEN);  /* IPv4 source */
   memcpy(&p_p->High.PeerAddress,&hdrp[16],IP4_ADDR_LEN);  /* IPv4 dest */
#  endif
   prot = p_p->TransAddrType = hdrp[9];  /* IPv4 Protocol Type */
   if (hdrp[6] & 0x1F != 0 || hdrp[7] != 0) {  /* Fragment offset != 0 */
      zero_pkt_fields(BAD_TRANS, p_p);  /* Can't see into fragment */
      return 0;
      }
   dx = (hdrp[0] & 0x0F) << 2;  /* HLEN */
   /* Data offset.  HLEN = IPv4 header length in 32-bit units */
   if (prot == PT_ICMP) {
      if (hl < dx+2) {  /* Didn't get the type,code fields */
         zero_pkt_fields(BAD_TRANS, p_p);
         return 0;
         }
      p_p->Low.TransAddress = htons(hdrp[dx]);  /* Type field */
      p_p->High.TransAddress = htons(hdrp[dx+1]);  /* Code field */
      }
   else {
      if (hl < dx+4) {  /* Didn't get the IP ports! */
         zero_pkt_fields(BAD_TRANS, p_p);
         return 0;
         }
      p_p->Low.TransAddress = *(Bit16 *)&hdrp[dx];  /* Source port */
      p_p->High.TransAddress = *(Bit16 *)&hdrp[dx+2];  /* Dest port */
         /* In **network** order within Bit16, to match rule values */
      }
#  if NEW_ATR
#   if OAM
   p_p->ip_id = *(Bit16 *)&hdrp[4];  /* IPv4 identification */
   p_p->High.PeerAddress.qbyte = *(Bit32 *)&hdrp[16];  /* IPv4 dest */
#   endif
   if (prot == PT_TCP) {
      if (hl < dx+4+sizeof(p_p->pi.tcp.th)) {  /* Didn't get the tcp header */
         p_p->pi.tcp.tcp_len = 0;
         memset(&p_p->pi.tcp.th, 0, sizeof(p_p->pi.tcp.th));
         p_p->pktinfo_sz = 0;
         }
      else {
         memcpy(&p_p->pi.tcp.th, &hdrp[dx+4],
            p_p->pktinfo_sz = sizeof(p_p->pi.tcp.th));
         p_p->pi.tcp.tcp_len = (hdrp[2] << 8 | hdrp[3]) - dx;
         }
      }
   else if (prot == PT_UDP) {
      if (hl < dx+8+sizeof(p_p->pi.udp.dns)) {  /* Only do dns for now */
         /* Didn't get enough UDP data */
         memset(&p_p->pi.udp, 0, sizeof(p_p->pi.udp));
         p_p->pktinfo_sz = 0;
         }
      else {
         memcpy(&p_p->pi.udp, &hdrp[dx+8],
            p_p->pktinfo_sz = sizeof(p_p->pi.udp));
         }
      }
   else if (prot == PT_ICMP) {
      if (hl < dx+4+sizeof(p_p->pi.icmp)) {  /* Didn't get enough ICMP data */
         memset(&p_p->pi.icmp, 0, sizeof(p_p->pi.icmp));
         p_p->pktinfo_sz = 0;
         }
      else {
         memcpy(&p_p->pi.icmp, &hdrp[dx+4],
            p_p->pktinfo_sz = sizeof(p_p->pi.icmp));
         }
      }
#  endif  /* NEW_ATR */
   return 1;
   }

int extract_IP4_udp_only(struct pkt *p_p, 
   const Bit8 *hdrp, const int hl)
{
   int prot, dx;

   if (hl < 0) {  /* Didn't get the header! */
      zero_pkt_fields(BAD_ADJ, p_p);
      return 0;
      }
   prot = p_p->TransAddrType = hdrp[9];  /* IPv4 Protocol Type */
   if (prot != PT_UDP) return 0;

   p_p->PeerAddrType = AT_IP4;
   p_p->invalid_addrs = 0;
   if (hl < 12+IP4_ADDR_LEN*2) {  /* Didn't get the peer addresses! */
      zero_pkt_fields(BAD_PEER, p_p);
      return 0;
      }
#  if QBYTE_PEER
   p_p->Low.PeerAddress.qbyte = *(Bit32 *)&hdrp[12];  /* IPv4 source */
   p_p->High.PeerAddress.qbyte = *(Bit32 *)&hdrp[16];  /* IPv4 dest */
#  else
   memcpy(&p_p->Low.PeerAddress,&hdrp[12],IP4_ADDR_LEN);  /* IPv4 source */
   memcpy(&p_p->High.PeerAddress,&hdrp[16],IP4_ADDR_LEN);  /* IPv4 dest */
#  endif
   if (hdrp[6] & 0x1F != 0 || hdrp[7] != 0) {  /* Fragment offset != 0 */
      zero_pkt_fields(BAD_TRANS, p_p);  /* Can't see into fragment */
      return 0;
      }
   dx = (hdrp[0] & 0x0F) << 2;  /* HLEN */
   /* Data offset.  HLEN = IPv4 header length in 32-bit units */

   if (hl < dx+4) {  /* Didn't get the IP ports! */
      zero_pkt_fields(BAD_TRANS, p_p);
      return 0;
      }
   p_p->Low.TransAddress = *(Bit16 *)&hdrp[dx];  /* Source port */
   p_p->High.TransAddress = *(Bit16 *)&hdrp[dx+2];  /* Dest port */
      /* In **network** order within Bit16, to match rule values */

#  if NEW_ATR
   if (hl < dx+8+sizeof(p_p->pi.udp.dns)) {  /* Only do dns for now */
      /* Didn't get enough UDP data */
      memset(&p_p->pi.udp, 0, sizeof(p_p->pi.udp));
      p_p->pktinfo_sz = 0;
      }
   else {
      memcpy(&p_p->pi.udp, &hdrp[dx+8],
         p_p->pktinfo_sz = sizeof(p_p->pi.udp));
      }
#  endif  /* NEW_ATR */
   return 1;
   }

int select_pkt(struct pkt *pp,
   const Bit16 ether_type, const Bit16 lsap,
   const Bit8 *ethp, 
   const Bit8 *p, const int pl)
{
   switch (ether_type) {
   case 0x0800:
#  if V6
      if ((p[0] & 0xF0) == 0x40) {
         pkt_extract(pp, AT_IP4, p,pl);
         if (use_ip_length) pp->p_len = p[2] << 8 | p[3];
         return 1;
         }
      else if ((p[0] & 0xF0) == 0x60) {
         pkt_extract(pp, AT_IP6, p,pl);
         if (use_ip_length) pp->p_len = p[4] << 8 | p[5];
         return 1;
         }
#  else
      if (extract_IP4_udp_only(pp, p,pl)) {
         if (use_ip_length) pp->p_len = p[2] << 8 | p[3];
         return 1;
         }
      else return 0;
#  endif
      break;
      }
   return 0;
   }
# endif  /* SELECT_TEST */

#if 0  /* ??????????????????? */
void pkt_from_raw(struct pkt *pp, struct raw_pkt *rp)
{
   pp->Priority = rp->Priority;  pp->VLANid = rp->VLANid;
   pp->arrival_time = rp->arrival_time;  pp->p_len = rp->p_len;

   switch (rp->ether_type) {
   case 0x0800:
      pkt_extract(pp, AT_IP4, rp->header,rp->h_len);
      break;
#if V6
   case 0x86DD:  /* RFC 2464, IPv6 packets over Ethernet */
      pkt_extract(pp, AT_IP6, rp->header, rp->h_len);
      break;
#endif
      }

   if (adj_reqd) {
      pp->Low.AdjAddr_ms4 = rp->SrcAdjAddr_ms4;  /* Source */
      pp->Low.AdjAddr_ls2 = rp->DestAdjAddr_ls2;
      pp->High.AdjAddr_ms4 = rp->SrcAdjAddr_ms4;  /* Dest */
      pp->High.AdjAddr_ls2 = rp->DestAdjAddr_ls2;
      }
   }

int raw_extract_ip4(struct raw_pkt *rp, const Bit8 *hdrp, const int hl)
{
   int dx;

   if (ntohs(*(Bit16 *)&hdrp[6]) & 0x1FFF != 0)  /* Frag offset != 0 */
      return 0;
   rp->v_t.TransType = hdrp[9];  /* IPv4 Protocol Type */
#if QBYTE_PEER
   rp->v_t.SrcPeerAddr = *(Bit32 *)&hdrp[12];  /* IPv4 source */
   rp->v_t.DestPeerAddr = *(Bit32 *)&hdrp[16];  /* IPv4 dest */
#else
   memcpy(&rp->v_t.SrcPeerAddr,&hdrp[12],IP4_ADDR_LEN);  /* IPv4 source */
   memcpy(&rp->v_t.DestPeerAddr,&hdrp[16],IP4_ADDR_LEN);  /* IPv4 dest */
#endif

   dx = (hdrp[0] & 0x0F) << 2;  /* HLEN */
   /* Data offset.  HLEN = IPv4 header length in 32-bit units */

   if (rp->v_t.TransType == PT_TCP || rp->v_t.TransType == PT_UDP) {
      if (hl < dx+4)  /* Didn't get the IP ports! */
         return 0;
      rp->v_t.SrcTransAddr = *(Bit16 *)&hdrp[dx];  /* Source port */
      rp->v_t.DestTransAddr = *(Bit16 *)&hdrp[dx+2];  /* Dest port */
         /* In **network** order within Bit16, to match rule values */
      }
   else {
      rp->v_t.SrcTransAddr = rp->v_t.DestTransAddr = 0;  /* No port nbrs */
      }
   return 1;
   }

int build_rawpkt(struct raw_pkt *rp,
   Bit16 ether_type, Bit16 lsap, const Bit8 *ethp, 
   Bit8 *p, int pl)  /* p,pl are what's left after stripping encapsulation */
{
   struct snap_hdr *sh;
   struct flow fp;
   int r = 0;

#if V6_DEBUG
   printf("process raw packet\n");
#endif

   if (ether_type == 0x8100) {  /* 802.1q frame */
      rp->Priority = p[0] >> 5;
      rp->VLANid = *(Bit16 *)&p[0] & 0x0FFF;
         /* In *network* order within Bit16, to match rule values */

      p += 2;  /* Move past the 802.1q tag */
      ether_type = ntohs(*(Bit16 *)p);
      p += 2;  pl -= 4;  /* Move past the Len/Etype */
      if (ether_type <= 1500) {  /* 802.3 packet */
         sh = (struct snap_hdr *)p;
         if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
            ether_type = ntohs(sh->etype);
            p += sizeof(struct snap_hdr);  pl -= sizeof(struct snap_hdr);
            }
         else ether_type = 0;  /* Other 802.2 packet */
         }
      else lsap = 0;  /* Blue book packet */
      }
   else {
      rp->Priority = 0;  rp->VLANid = 0;
      }
   rp->ether_type = ether_type;  rp->lsap = lsap;

   switch (ether_type) {
   case 0x0800:
      if ((p[0] & 0xF0) == 0x40) {
         if (use_ip_length) rp->p_len = ntohs(*(Bit16 *)&p[2]);
	 r = raw_extract_ip4(rp, p,pl);
         }
      break;
#if V6
   case 0x86DD:  /* RFC 2464, IPv6 packets over Ethernet */
      if ((p[0] & 0xF0) == 0x60) {
         if (use_ip_length) rp->p_len = ntohs(*(Bit16 *)&p[4]);
	 r = raw_extract_ip6(rp, p,pl);
         }
      break;
#endif
      }

   if (r && adj_reqd) {
      rp->SrcAdjAddr_ms4 = *(Bit32 *)&ethp[6];  /* Source */
      rp->DestAdjAddr_ls2 = *(Bit16 *)&ethp[10];
      rp->SrcAdjAddr_ms4 = *(Bit32 *)&ethp[0];  /* Dest */
      rp->DestAdjAddr_ls2 = *(Bit16 *)&ethp[4];
      }

#if MULTI
   /* Determine hash group for multiple pme/count threads */

# if N_PME_THREADS > 1 || N_COUNT_THREADS > 1
   rp->hash_group =
#  if QBYTE_PEER
      rp->v_t.SrcPeerAddr * rp->v_t.DestPeerAddr & 0x0400 ? 0 : 1;
#  else
      rp->v_t.SrcPeerAddr[(PEER_ADDR_LEN+3)/4 - 1] *
         rp->v_t.DestPeerAddr[(PEER_ADDR_LEN+3)/4 - 1] & 0x0400 ? 0 : 1;
#  endif
# else
   rp->hash_group = 0;  /* Only run one thread */
# endif
#endif  /* MULTI */

   if (r) {
      if (!lookup_stream(rp))
         return 0;  /* Stream being ignored */
      memcpy(rp->header, p, rp->h_len = pl);
      return 1;
      }
   return 0;
   }
#endif  /* ??????????????????? */

void other_extract(struct pkt *p_p,
   const Bit16 ethertype, const Bit16 lsap)
{
   p_p->PeerAddrType = AT_OTHER;
   memset(&p_p->Low.PeerAddress.byte, 0, sizeof(p_p->Low.PeerAddress));
   memset(&p_p->High.PeerAddress.byte, 0, sizeof(p_p->High.PeerAddress));
   p_p->Low.PeerAddress.trans = htons((Bit16)ethertype);  /* Blue Book type */
   p_p->High.PeerAddress.trans = htons((Bit16)lsap);  /* 802.2 LSAP */
   p_p->TransAddrType = 0;
   p_p->Low.TransAddress = p_p->High.TransAddress = 0;
   }

int handle_pkt(struct pkt *p_p,
   Bit16 ether_type, Bit16 lsap, const Bit8 *ethp, 
   Bit8 *p, int pl)  /* What's left after stripping encapsulation */
{
   struct snap_hdr *sh;
   int r = 0;

#if V6_DEBUG
   printf("handle packet\n");
#endif
   if (ether_type == 0x8100) {  /* 802.1q frame */
      p_p->Priority = p[0] >> 5;
      p_p->VLANid = *(Bit16 *)&p[0] & 0x0FFF;
         /* In *network* order within Bit16, to match rule values */
      p += 2;  /* Move past the 802.1q tag */
      ether_type = ntohs(*(Bit16 *)p);
      p += 2;  pl -= 4;  /* Move past the Len/Etype */
      if (ether_type <= 1500) {  /* 802.3 packet */
         sh = (struct snap_hdr *)p;
         if ((lsap = ntohs(sh->lsap)) == 0xAAAA) {  /* SNAP packet */
            ether_type = ntohs(sh->etype);
            p += sizeof(struct snap_hdr);  pl -= sizeof(struct snap_hdr);
            }
         else ether_type = 0;  /* Other 802.2 packet */
         }
      else lsap = 0;  /* Blue book packet */
      /*printf("====> VLANid=%04x, Priority=%d, ether_type=%04x\n",
         p_p->VLANid, p_p->Priority, ether_type);  fflush(stdout);  /**/
      }

   switch (ether_type) {
   case 0x0800:
      if ((p[0] & 0xF0) == 0x40) {
         if (use_ip_length) p_p->p_len = ntohs(*(Bit16 *)&p[2]);
         r = pkt_extract(p_p, AT_IP4, p,pl);
         }
      break;
#if V6
   case 0x86DD:  /* RFC 2464, IPv6 packets over Ethernet */
      if ((p[0] & 0xF0) == 0x60) {
         if (use_ip_length) p_p->p_len = ntohs(*(Bit16 *)&p[4]);
         r = pkt_extract(p_p, AT_IP6, p,pl);
         }
      break;
#endif
   case 0x809B:
      if (proto_reqd[AT_ETHERTALK]) r = pkt_extract(p_p, AT_ETHERTALK, p,pl);
      break;
   case 0x8137:
      if (proto_reqd[AT_NOVELL]) r = pkt_extract(p_p, AT_NOVELL, p,pl);
      break;
   case 0x6003:
      if (proto_reqd[AT_DECNET]) r = pkt_extract(p_p, AT_DECNET, p,pl);
      break;
   case 0x0000:  /* 802.3 packet other than SNAP */
      switch (lsap) {
      case 0xFFFF:
         if (proto_reqd[AT_NOVELL]) r = pkt_extract(p_p, AT_NOVELL, p,pl);
         break;  /* Novell "Raw 802.2" doesn't use LLC */
#ifdef CLNS
      case 0xFEFE:  /* CLNS */
         if (proto_reqd[AT_CLNS]) r = pkt_extract(p_p, AT_CLNS, p+2,pl-2);
         break;  /* ISO 8473-1 uses 1-org, byte 0 is LLC control byte */
#endif
      case 0xE0E0:  /* Novell 802.2 */
         if (proto_reqd[AT_NOVELL]) r = pkt_extract(p_p, AT_NOVELL, p+3,pl-3);
         break;
/*    case 0xF0F0:  NetBIOS */
         }
      }
   if (r = 0 && proto_reqd[AT_OTHER]) {
      other_extract(p_p, ether_type,lsap);  r = 1;
      }

   if (adj_reqd && p_p->PeerAddrType != AT_DUMMY) {
      p_p->Low.AdjAddr_ms4 = *(Bit32 *)&ethp[6];  /* Source */
      p_p->Low.AdjAddr_ls2 = *(Bit16 *)&ethp[10];
      p_p->High.AdjAddr_ms4 = *(Bit32 *)&ethp[0];  /* Dest */
      p_p->High.AdjAddr_ls2 = *(Bit16 *)&ethp[4];
      }

/*   printf(">IPv4+%d, ", p_p->PeerAddrType); /**/

#if MULTI
# if N_PME_THREADS > 1 || N_COUNT_THREADS > 1
   rp->hash_group =
#  if QBYTE_PEER
      rp->v_t.SrcPeerAddr * rp->v_t.DestPeerAddr & 0x0400 ? 0 : 1;
#  else
      rp->v_t.SrcPeerAddr[(PEER_ADDR_LEN+3)/4 - 1] *
         rp->v_t.DestPeerAddr[(PEER_ADDR_LEN+3)/4 - 1] & 0x0400 ? 0 : 1;
#  endif
#else
   rp->hash_group = 0;  /* Only run one thread */
# endif

   if (r) return lookup_stream(p_p);
   return 0;
   }

#endif  /* !NF_CISCO_DATA && !LFAP_METER */


#ifdef DOS
void save_time(void)
{
   s_tod_h = tod_h;  s_tod_m = tod_m;  s_tod_s = tod_s;
   elapsed_sec = 0;
   }
#endif

char *u_fmt(char *buf, Bit32 n)
{
   if (n < 1024)
      sprintf(buf, "[%u B]", n);
   else if (n < 1024*1024)
      sprintf(buf, "[%u kB]", (n+512)/1024);
   else
      sprintf(buf, "[%u MB]", (n+512*1024)/(1024*1024));
   return buf;
   }

void show_memory(void)
{
   char msg[90], nb[30];
   int t, r,rh, f,fh, s,sd, d,de, p, o, h, k;

   h = mxrawpkts*sizeof(struct raw_pkt);
   k = mxpkts*sizeof(struct pkt);
   r = mxrules*sizeof(struct rule);
   rh = mxrulehash*sizeof(Bit16);
   f = mxflows*sizeof(struct flow);
   fh = fthashmod*sizeof(struct flow *);
#if NEW_ATR
   s = mxstreams*sizeof(struct stream) + sfhashmod*sizeof(struct stream *);
   sd = mxstr_blocks*sizeof(struct stream_data);
   d = mxdistribs*sizeof(struct distribution);
   de = mxdistevents*sizeof(struct event);
   p = mxpktdatas*sizeof(struct pktdata);
# if OAM
   o = mxoamrecs*sizeof(struct OAMrec);
# endif
#else
   s = sd = 0;
   d = de = p = 0;
#endif
   t = h+k+r+rh + f+fh + s+sd + d+de + p;

   display_msg(1,"Memory Usage Info ..");
   sprintf(msg, "Rules: %lu max, %lu free %s", 
      mxrules, mxrules-inuse_rules, u_fmt(nb,r));
   display_msg(0,msg);
   sprintf(msg, "RuleHash: %lu max, %lu free %s", 
      mxrulehash, mxrulehash-inuse_rule_hash, u_fmt(nb,rh));
   display_msg(0,msg);
   sprintf(msg, "Flows: %lu max (%d B/flow) %s", 
      mxflows, sizeof(struct flow), u_fmt(nb,f));
   display_msg(0,msg);
   sprintf(msg, "FlowHash: %lu slots %s",
      fthashmod, u_fmt(nb,fh));
   display_msg(0,msg);
#if NEW_ATR
   sprintf(msg, "TCP streams: %lu max, %lu free %s",
      mxstreams, n_free_streams, u_fmt(nb,s));
   display_msg(0,msg);
   sprintf(msg, "Flows with streams: %lu alloc, %lu free (%d B/str) %s",
      mxstr_blocks, n_free_str_blocks, sizeof(struct stream_data), u_fmt(nb,sd));
   display_msg(0,msg);
   sprintf(msg, "Distribs: %lu max, %lu free (%d B/dist) %s",
      mxdistribs, n_free_distribs, sizeof(struct distribution), u_fmt(nb,d));
   display_msg(0,msg);
   sprintf(msg, "Distrib Events: %lu alloc, %lu free %s",
      mxdistevents, n_free_events, u_fmt(nb,de));
   display_msg(0,msg);
   sprintf(msg, "Packet data: %lu alloc, %lu free (%d B/pkt) %s",
      mxpktdatas, n_free_pktdata, sizeof(struct pktdata), u_fmt(nb,p));
   display_msg(0,msg);
# if OAM
   sprintf(msg, "OAM records: %lu alloc, %lu free (%d B/rec) %s",
      mxoamrecs, n_free_oamrecs, sizeof(struct OAMrec), u_fmt(nb,o));
   display_msg(0,msg);
# endif
#endif
   sprintf(msg, "Header structs: %lu alloc, %lu free (%d B/rec) %s",
      mxrawpkts, n_free_rawpkts, sizeof(struct raw_pkt), u_fmt(nb,h));
   display_msg(0,msg);
   sprintf(msg, "Pkt structs: %lu alloc, %lu free (%d B/rec) %s",
      mxpkts, n_free_pkts, sizeof(struct pkt), u_fmt(nb,k));
   display_msg(0,msg);

#if defined(DOS)
   sprintf(msg, "malloc(): %lu bytes free", coreleft());
   display_msg(0,msg);
#else
   sprintf(msg, "Total allocated data: %s", u_fmt(nb,t));
   display_msg(0,msg);
#endif
   }

#if NEW_ATR
void show_new_attrib(void)
{
   char msg[60];
   display_msg(1,"New Attribute Info ..");
   sprintf(msg, "Streams (-t): %lu in use, %lu max",
      mxstreams-n_free_streams, mxstreams);
   display_msg(0,msg);
   sprintf(msg,"  %lu recovered", StreamsRecovered);
   display_msg(0,msg);
   if (stats_time != 0) {
      sprintf(msg,"  Creating   %.03f stream/s", (double)StreamsCreated/stats_time);
      display_msg(0,msg);
      sprintf(msg,"  Recovering %.03f stream/s", (double)StreamsRecovered/stats_time);
      display_msg(0,msg);
      }
   sprintf(msg, "Packet data (-a): %lu in use, %lu max",
      mxpktdatas-n_free_pktdata, mxpktdatas);
   display_msg(0,msg);
   sprintf(msg,"  %lu recovered", PktsRecovered);
   display_msg(0,msg);
   if (stats_time != 0) {
      sprintf(msg,"  Creating   %.03f pktdata/s", (double)PktsCreated/stats_time);
      display_msg(0,msg);
      sprintf(msg,"  Recovering %.03f pktdata/s", (double)PktsRecovered/stats_time);
      display_msg(0,msg);
      }
   }
#endif

void show_chains(int reset)
{
   char msg[60];

   display_msg(1,"Ruleset Chain Info ..");
   sprintf(msg, "%d tests", rsc_n_searches);
   display_msg(0,msg);
   if (rsc_n_searches == 0) return;
   sprintf(msg, "Range: %lu max, %lu av", 
      rsc_mx_range, rsc_av_range/rsc_n_searches);
   display_msg(0,msg);
   sprintf(msg, "Tests: %lu max, %lu av", 
      rsc_mx_tests, rsc_av_tests/rsc_n_searches);
   display_msg(0,msg);

   if (reset) {
      rsc_n_searches = 
         rsc_mx_range = rsc_av_range =
         rsc_mx_tests = rsc_av_tests = 0;
      }
   }

Bit32 active_flows(void)
{
   Bit32 af = 0, j, n;
   struct rtinf_rec *rip;

   for (j = 0; j != sizeof(ri)/sizeof(struct rtinf_rec); ++j) {
      rip = &ri[j];
      if (rip->ri_Status != RS_ACTIVE &&
            rip->ri_Status != RS_NOTINSERVICE
         ) continue;
      n = rip->ri_FlowRecords < rip->ri_recoverable_flows ? 0 :
         rip->ri_FlowRecords - rip->ri_recoverable_flows;
      af += n;
      }
   return af;
   }

void show_flow_table(void)
{
   char msg[60];
   Bit32 f;
   display_msg(1,"Flow Table Info ..");
   sprintf(msg, "InactTime %d, Flood %d",
      InactivityTimeout,FloodMark);
   display_msg(0,msg);
   sprintf(msg, "Flows: %lu active, %u used",
      active_flows(), nflows);
   display_msg(0,msg);
   sprintf(msg,"  %lu recovered (GC: %u s, %u flow)",
      FlowsRecovered, gc_interval,gc_f);
   display_msg(0,msg);
   if (stats_time != 0) {
      f = FlowsCreated*1000L/stats_time;
      sprintf(msg,"  Creating   %lu.%03lu flow/s", f/1000,f%1000);
      display_msg(0,msg);
      f = FlowsRecovered*1000L/stats_time;
      sprintf(msg,"  Recovering %lu.%03lu flow/s", f/1000,f%1000);
      display_msg(0,msg);
      }
   }

void show_protocols(void)
{
   int j;
   char msg[60];
   display_msg(1,"Protocols being metered ..");
   sprintf(msg,"      %3.3s  %s",  adj_reqd ? "Yes" : " No", "Adjacent");
   display_msg(0,msg);
#if NF_OCX_BGP
   sprintf(msg,"      %3.3s  %s",  asn_lookup ? "Yes" : " No", "ASN lookup");
   display_msg(0,msg);
#endif
   for (j = 0; j != sizeof(proto_reqd)/sizeof(int); ++j) {
      if (proto_names[j][0] != '\0') {
         sprintf(msg,"  %2d  %3.3s  %s",
            j, proto_reqd[j] ? "Yes" : " No", proto_names[j]);
         display_msg(0,msg);
         }
      }
   }

void zero_stats(int show_msg)
{
   FlowsCreated = FlowsRecovered =
#if NEW_ATR
      PktsCreated = PktsRecovered =  StreamsCreated = StreamsRecovered =
#endif
      n_matches = n_hash_compares = n_hash_searches = 0L;
   clear_pkt_stats = 1;
   if (show_msg) {
#ifdef DOS
      scpos(0,scr_lrow);  printf("Statistics Zeroed");
#else
      display_msg(0,"Statistics Zeroed");
#endif
      }
   }

void show_stats(void)
{
   int i,j;
   double aps;
   Bit32 apb, kdp;
   char msg[60];
#ifdef DOS
   if (stats_time == 0 || npackets == 0 ||
     kilodummypackets == 0 || mindummyrate == 0)
#else
   if (stats_time == 0 || npackets == 0)
      return;  /* Avoid divides by zero */
#endif

   display_msg(1,"Meter Statistics ..");
   aps = (double)npackets/(double)stats_time;
#ifdef DOS
   apb = (t_backlog*10+5L)/(stats_time*10L);
   sprintf(msg,"Av pkt/s %u, av pkt backlog %u", aps,apb);
   display_msg(0,msg);
   sprintf(msg,"Max pkt/s %u, max pkt backlog %u",
      max_pkt_rate,max_pkt_backlog);
   display_msg(0,msg);
   if (kilodummypackets != 0) {
      if (dummypackets >= 500) ++kilodummypackets;
      i = kilodummypackets*1000L/(kilodummypackets+npackets/1000L);
      j = (mindummyrate*10000L+5L)/((mindummyrate+mdpacketrate)*10L);
      sprintf(msg,"Idle time av %u.%u, min %u.%u %", i/10,i%10, j/10,j%10);
      display_msg(0,msg);
      }
#else
   sprintf(msg,"Av pkt/s %.02f, max pkt/s %u", aps,max_pkt_rate);
   display_msg(0,msg);
#endif
   sprintf(msg,"%lu flows active (max %lu)",active_flows(),mxflows);
   display_msg(0,msg);
   sprintf(msg,"%u masks in table (max %u)", n_masks,MXMASKS);
   display_msg(0,msg);
   i = (n_matches*100L+5L)/(npackets*10L);
   j = (n_hash_searches*100L+5L)/(npackets*10L);
   sprintf(msg,"%u.%u rules/pkt, %u.%u searches/pkt",
      i/10,i%10, j/10,j%10);
   display_msg(0,msg);
   if (n_hash_searches != 0) {
      i = (n_hash_compares*100L+5L)/(n_hash_searches*10L);
      sprintf(msg,"%u.%u compares/search", i/10,i%10);
      display_msg(0,msg);
      sprintf(msg,"%u hash slots, %u in use, ", fthashmod,n_hash_ents);
      }
   }

void show_rulesets(void)
{
   int c,j,t;
   struct rtinf_rec *rip;
   char buf[80];
   display_msg(1,"Ruleset Table ..");
   for (c = t = j = 0; j != sizeof(ri)/sizeof(struct rtinf_rec); ++j) {
      rip = &ri[j];
      if (rip->ri_Status != RS_ACTIVE &&
            rip->ri_Status != RS_NOTINSERVICE
         ) continue;
      ++c;
      if (t == 0) {
         display_msg(0,"   Rdy  Flows Rules  Name    Owner");
         t = 1;
         }
      sprintf(buf, "%2d  %c  %5lu  %5u  %s  %s",
         j+1,  /* 1-org */
         rip->ri_Status == RS_ACTIVE ? 'T' : 'F',
         rip->ri_FlowRecords,
         rip->ri_Size, rip->ri_Name,
         rip->ri_Owner);
      display_msg(0,buf);
      }
   if (c == 0) display_msg(0,"No ruleset rows active");
   }

void show_managers(void)
{
   int c,j,t;
   struct mgr_rec *mip;
   char buf[80];
   display_msg(1,"Manager Table ..");
   for (c = t = j = 0; j != sizeof(mi)/sizeof(struct mgr_rec); ++j) {
      mip = &mi[j];
      if (mip->mi_Status != RS_ACTIVE) continue;
      ++c;
      if (t == 0) {
         display_msg(0,"  Crnt Stby HWM RSby  Owner");
         t = 1;
         }
      sprintf(buf, "%2d  %2d  %2d  %3d   %c  %s",
         j+1,  /* 1-org */
         mip->mi_CurrentRuleSet, mip->mi_StandbyRuleSet,
         mip->mi_HighWaterMark,
         mip->mi_RunningStandby == TV_TRUE ? 'T' : 'F',
         mip->mi_Owner);
      display_msg(0,buf);
      }
   if (c == 0) display_msg(0,"No manager rows active");
   }

void show_readers(void)
{
   int c,j,t;
   struct rdr_rec *cip;
   Bit32 now;
   char buf[80];
   display_msg(1,"Meter Reader Table ..");
   now = uptime_cs();
   for (c = t = j = 0; j != sizeof(ci)/sizeof(struct rdr_rec); ++j) {
      cip = &ci[j];
      if (cip->ci_Status != RS_ACTIVE) continue;
      ++c;
      if (t == 0) {
         display_msg(0,"    Rsx  Last  Prev  Owner");
         t = 1;
         }
      sprintf(buf, "%2d  %2d  %5lu %5lu  %s",
         j+1,  /* 1-org */
         cip->ci_RuleSet,
         (now - cip->ci_LastTime)/100L, (now - cip->ci_PrevTime)/100L,
         cip->ci_Owner);
      display_msg(0,buf);
      }
   if (c == 0) display_msg(0,"No reader rows active");
   }

#if MULTI
# if THREAD_TRACE
double ntm_start_s;

void mutex_lock(char *caller, pthread_mutex_t *m)
{
   struct timeval t; double ml_s, mp_s, w;

   gettimeofday(&t, (struct timezone *)0);
   ml_s = t.tv_sec + t.tv_usec/1000000.0;

   tw_pthread_mutex_lock(m);

   gettimeofday(&t, (struct timezone *)0);
   mp_s = t.tv_sec + t.tv_usec/1000000.0;

   if ((w = mp_s - ml_s) > 0.000150) {  /* 150 us */
      fprintf(multi_log, "t %12.6f %10.6f m %3s %x\n",
         ml_s - ntm_start_s, w, caller, m);
      fflush(multi_log);
      }
   }

void ntm_semaphore_down(char *caller, Semaphore *s)
{
   struct timeval t;  double sl_s, sp_s, w;
   int v;

   gettimeofday(&t, (struct timezone *)0);
   sl_s = t.tv_sec + t.tv_usec/1000000.0;

   v = semaphore_down(s);

   gettimeofday(&t, (struct timezone *)0);
   sp_s = t.tv_sec + t.tv_usec/1000000.0;

   if ((w = sp_s - sl_s) > 0.000300) {  /* 300 us */
      fprintf(multi_log, "t %12.6f %10.6f s %3s %x\n",
         sl_s - ntm_start_s, w, caller, s);
      fflush(multi_log);
      }
   }
# endif

void init_mutex(pthread_mutex_t *m, char *name)
{
# if THREAD_TRACE
   fprintf(multi_log, "a m %x %s\n", m, name);
# endif
   if (pthread_mutex_init(m, pthread_mutexattr_default) == -1)
      log_msg(LOG_ERR, 21, "Couldn't init %s", name);

   }

void init_mutexes(void)
{
# if THREAD_TRACE
   struct timeval t;
   gettimeofday(&t, (struct timezone *)0);
      /* Initiallise threads tod clock */
   ntm_start_s = t.tv_sec + t.tv_usec/1000000.0;
   if ((multi_log = fopen("multi_log.txt", "w")) == NULL)
      log_msg(LOG_ERR, 999, "Couldn't open multi_log.txt file");
# endif

   init_mutex(&pkt_fl_mutex, "raw_fl_mutex");
   init_mutex(&pkt_fl_mutex, "pkt_fl_mutex");
   init_mutex(&dist_fl_mutex, "dist_fl_mutex");
   init_mutex(&event_fl_mutex, "event_fl_mutex");
   init_mutex(&stdata_fl_mutex, "stdata_fl_mutex");
   init_mutex(&stream_fl_mutex, "stream_fl_mutex");
   init_mutex(&pktdata_fl_mutex, "pktdata_fl_mutex");
# if OAM
   init_mutex(&oamrec_fl_mutex, "oamrec_fl_mutex");
# endif

   init_mutex(&flow_table_mutex, "flow_table_mutex");
   init_mutex(&stream_q_mutex, "stream_q_mutex");
   init_mutex(&strhash_q_mutex, "strhash_q_mutex");
   init_mutex(&pktdata_q_mutex, "pktdata_q_mutex");
   init_mutex(&dev_q_mutex, "dev_q_mutex");
   init_mutex(&event_q_mutex, "event_q_mutex");
# if OAM
   init_mutex(&oam_q_mutex, "oam_q_mutex");
# endif
   init_mutex(&if_pkt_q_mutex, "start_time_mutex");
   init_mutex(&if_pkt_q_mutex, "log_file_mutex");
   init_mutex(&if_pkt_q_mutex, "if_pkt_q_mutex");
   }

void destroy_mutex(pthread_mutex_t *m, char *name)
{
   if (pthread_mutex_destroy(m) == -1)
     log_msg(LOG_ERR, 21, "Couldn't destroy %s", name);
   }

void destroy_mutexes(void)
{
   destroy_mutex(&pkt_fl_mutex, "pkt_fl_mutex");
   destroy_mutex(&dist_fl_mutex, "dist_fl_mutex");
   destroy_mutex(&event_fl_mutex, "event_fl_mutex");
   destroy_mutex(&stdata_fl_mutex, "stdata_fl_mutex");
   destroy_mutex(&stream_fl_mutex, "stream_fl_mutex");
   destroy_mutex(&pktdata_fl_mutex, "pktdata_fl_mutex");
# if OAM
   destroy_mutex(&oamrec_fl_mutex, "oamrec_fl_mutex");
# endif
   init_mutex(&if_pkt_q_mutex, "start_time_mutex");
   init_mutex(&if_pkt_q_mutex, "log_file_mutex");
   destroy_mutex(&if_pkt_q_mutex, "if_pkt_q_mutex");

   destroy_mutex(&flow_table_mutex, "flow_table_mutex");
   destroy_mutex(&stream_q_mutex, "stream_q_mutex");
   destroy_mutex(&strhash_q_mutex, "strhash_q_mutex");
   destroy_mutex(&pktdata_q_mutex, "pktdata_q_mutex");
   destroy_mutex(&dev_q_mutex, "dev_q_mutex");
   destroy_mutex(&event_q_mutex, "event_q_mutex");
# if OAM
   destroy_mutex(&oam_q_mutex, "oam_q_mutex");
# endif
   }

# if THREAD_TRACE
void ntm_semaphore_init(char *name, int id, Semaphore *s)
{
   if (id != 0) fprintf(multi_log, "a s %x %s.%d\n", s, name,id);
   else fprintf(multi_log, "a s %x %s\n", s, name);
   semaphore_init(s);
   }
# endif
#endif

void init_monitor(int n_interfaces)
{
   int j;

#ifdef DOS
   set_tod();
   save_time();  /* For screen display */
#endif
   start_uptime_clock();

   if ((rawpkta = (struct raw_pkt *)malloc(
        sizeof(struct raw_pkt)*mxrawpkts)) == NULL)
      log_msg(LOG_ERR, 1, "Not enough memory for pkt headers!");
   memset(rawpkta, 0, sizeof(struct raw_pkt)*mxrawpkts);
   free_rawpkts = rawpkta;  n_free_rawpkts = mxrawpkts;
   for (j = 0; j != mxrawpkts-1; ++j) rawpkta[j].next_rp = &rawpkta[j+1];
   rawpkta[mxrawpkts-1].next_rp = NULL;
#if RAW_DEBUG >= 1
   for (j = 0; j != mxrawpkts; ++j) rawpkta[j].pkt_state = 0;
#endif
   if ((pkta = (struct pkt *)malloc(
        sizeof(struct pkt)*mxpkts)) == NULL)
      log_msg(LOG_ERR, 2, "Not enough memory for pkt data!");
   free_pkts = pkta;  n_free_pkts = mxpkts;
   for (j = 0; j != mxpkts-1; ++j) pkta[j].next_pp = &pkta[j+1];
   pkta[mxpkts-1].next_pp = NULL;
#if PKT_DEBUG >= 1
   for (j = 0; j != mxpkts; ++j) pkta[j].pkt_state = 0;
#endif

   if (mxflows < 30) {
      log_msg(LOG_ERR, 3, "-f specified < 30 flows!  Using -f 50");
      mxflows = 50;
      }
   if ((fa = (struct flow *)malloc(
        sizeof(struct flow)*mxflows)) == NULL)
      log_msg(LOG_ERR, 4, "Not enough memory for flow table!");
   for (j = 0; j != mxflows; ++j) fa[j].FlowRuleSet = 0;

   for (j = 0; j != mxflows-1; ++j) fa[j].rs_next = j+2;  /* 1-org */
   fa[mxflows-1].rs_next = 0;
   free_flow_head = 1;  free_flow_tail = mxflows;

   rsc_n_searches = 
      rsc_mx_range = rsc_av_range =
      rsc_mx_tests = rsc_av_tests = 0;

#if FLOW_INDEX
   if ((flow_ix = (struct flow **)malloc(
         sizeof(struct flow *)*mxflows)) == NULL)
      log_msg(LOG_ERR, 5, "Not enough memory for flow index!");
   for (j = 0; j != mxflows; ++j) flow_ix[j] = NULL;
#endif

   nflows = 0;  /* No accounting flows in use yet */
   fthashmod = mxflows;  /* Doesn't need to be mutually prime */

#if 0
   for (j = sizeof(p2primes)/sizeof(Bit32)-1; 
      j != 8 && p2primes[j] > mxflows; --j) ;
   fthashmod = p2primes[j];  /* Min fthashmod = p2primes[8] (2039) */
#endif
   flow_ht = (struct flow **)malloc(fthashmod*sizeof(struct flow *));
   if (flow_ht == NULL)
      log_msg(LOG_ERR, 6, "Not enough memory for flow hash table!");
   memset(flow_ht, 0, fthashmod*sizeof(struct flow *));

   if ((rule_space = (struct rule *)malloc(
         sizeof(struct rule)*mxrules)) == NULL)
      log_msg(LOG_ERR, 7, "Not enough memory for rulesets!");
   inuse_rules = 0;

   mxrulehash = 1 + mxrules*3/2;
   if ((rule_hash_space = (Bit16 *)malloc(
         sizeof(Bit16)*mxrulehash)) == NULL)
      log_msg(LOG_ERR, 8, "Not enough memory for rule hashes!");
   inuse_rule_hash = 0;

#if NEW_ATR
   if ((sfa = (struct stream *)malloc(
        sizeof(struct stream)*mxstreams)) == NULL)
      log_msg(LOG_ERR, 9, "Not enough memory for streams!");
   free_streams = sfa;  n_free_streams = mxstreams;
   for (j = 0; j != mxstreams-1; ++j) sfa[j].next_sp = &sfa[j+1];
   sfa[mxstreams-1].next_sp = NULL;
   sfhashmod = mxstreams;  /* Doesn't need to be mutually prime */

#if 0
   for (j = sizeof(p2primes)/sizeof(Bit32)-1; 
      j != 8 && p2primes[j] > mxstreams; --j) ;
   sfhashmod = p2primes[j];
#endif
   sfht = (struct stream **)malloc(sfhashmod*sizeof(struct stream *));
   if (sfht == NULL)
      log_msg(LOG_ERR, 10, "Not enough memory for stream hash table!");
   memset(sfht, 0, sfhashmod*sizeof(struct stream *));

   if ((strb = (struct stream_data *)malloc(
        sizeof(struct stream_data)*mxstr_blocks)) == NULL)
      log_msg(LOG_ERR, 11, "Not enough memory for stream data blocks!");
   free_str_blocks = strb;  n_free_str_blocks = mxstr_blocks;
   for (j = 0; j != mxstr_blocks-1; ++j) strb[j].next = &strb[j+1];
   strb[mxstr_blocks-1].next = NULL;

# if TCP_PKT_TRACE
   pt_file = fopen(ptf_title, "a");
# endif

   if ((distribs = (struct distribution *)malloc(
        sizeof(struct distribution)*mxdistribs)) == NULL)
      log_msg(LOG_ERR, 12, "Not enough memory for distributions!");
   free_distribs = distribs;  n_free_distribs = mxdistribs;
   for (j = 0; j != mxdistribs-1; ++j) distribs[j].next = &distribs[j+1];
   distribs[mxdistribs-1].next = NULL;

   if ((events = (struct event *)malloc(
        sizeof(struct event)*mxdistevents)) == NULL)
      log_msg(LOG_ERR, 13, "Not enough memory for distrib events!");
   free_events = events;  n_free_events = mxdistevents;
   for (j = 0; j != mxdistevents-1; ++j) events[j].next = &events[j+1];
   events[mxdistevents-1].next = NULL;

   if ((packet_data = (struct pktdata *)malloc(
        sizeof(struct pktdata)*mxpktdatas)) == NULL)
      log_msg(LOG_ERR, 14, "Not enough memory for packet data blocks!");
   free_pkt_dat = packet_data;  n_free_pktdata = mxpktdatas;
   for (j = 0; j != mxpktdatas-1; ++j) packet_data[j].next = &packet_data[j+1];
   packet_data[mxpktdatas-1].next = NULL;

# if OAM
   if ((oar = (struct OAMrec *)malloc(
        sizeof(struct OAMrec)*mxoamrecs)) == NULL)
      log_msg(LOG_ERR, 15, "Not enough memory for OAM data records!");
   free_oamrecs = oar;  n_free_oamrecs = mxoamrecs;
   for (j = 0; j != mxoamrecs-1; ++j) oar[j].next = &oar[j+1];
   oar[mxoamrecs-1].next = NULL;
   memset(oaf, 0, sizeof(oaf));
# endif
#endif  /* NEW_ATR */

   memset(ri, 0, sizeof(dist_atr));
   memset(ri, 0, sizeof(stream_atr));
   for (j = 0; ; ++j) {
      if (attribs[j].attr == 0) break;
      dist_atr[attribs[j].attr] = attribs[j].distrib;
      stream_atr[attribs[j].attr] = attribs[j].stream;
      }

   memset(ri, 0, sizeof(ri));
   memset(rs_rdr, 0, sizeof(rs_rdr));  /* For nifty */
   /* Create a ruleset info entry for the default rule table */
   ri[0].ri_rule_table = (struct rule *)default_rule_table;
   ri[0].ri_Size = DRT_SIZE;
   optimise_rule_table(1);  /* Alloc rule hash */
   memcpy(ri[0].ri_Owner, "NeTraMet", 8);
   memcpy(ri[0].ri_Name, "1", 1);  /* For compatibility with v3 */
   ri[0].ri_TimeStamp = 1;
   ri[0].ri_Status = RS_ACTIVE;

   tbl_size[2] = n_interfaces;  /* Interface table */

   memset(mi, 0, sizeof(mi));  /* Manager info */
   for (j = 1; j != sizeof(mi)/sizeof(struct mgr_rec); ++j)
      mi[j].mi_RunningStandby = TV_FALSE;
   memcpy(mi[0].mi_Owner, "NeTraMet", 8);
   mi[0].mi_CurrentRuleSet = 1;
   mi[0].mi_RunningStandby = TV_FALSE;
   mi[0].mi_TimeStamp = 1;
   mi[0].mi_Status = RS_ACTIVE;

   init_stream_table();

   for (j = 0; j != sizeof(proto_reqd)/sizeof(int); ++j) proto_reqd[j] = 0;
   adj_reqd = 0;
   open_rule_set(1, 1); /* Open set 1 */

   memset(ci, 0, sizeof(ci));  /* Reader (collector) info */

#if USER_INFO
   UserInfoInit();
#endif
   }

void show_help(void)
{
   display_msg(0,"Copyright (C) 1992-2002");
   display_msg(0,"  Nevil Brownlee");
   display_msg(0,"  ITSS Technology Development");
   display_msg(0,"  The University of Auckland");
   display_msg(0,"");
   display_msg(0,"Keyboard commands ..");
   display_msg(0,"");
   display_msg(0,"  e: show mEter reader table");
   display_msg(0,"  a: show mAnager table");
   display_msg(0,"  u: show rUleset table");
   display_msg(0,"  f: show Flow Table");
   display_msg(0,"  p: show Protocols");
   display_msg(0,"  s: show Statistics");
   display_msg(0,"  v: show meter Version");
#if defined(DOS)
   display_msg(0,"  z: Zero statistics");
# if !(OCX_NTM || OC3_NTM)
   display_msg(0,"  b: show Bad packet counts");
# endif
   display_msg(0,"  m: show Memory usage");
#endif
   if (kb_enabled) {
      display_msg(0,"");
      display_msg(0,"Esc: stop metering, exit NeTraMet");
      }
   }

void handle_kb(int ch)
{
   int c;
   switch (ch) {
   case 'a':
      show_managers();
      break;
#if NEW_ATR
   case 'd':
      show_new_attrib();
      break;
#endif
   case 'C':
   case 'c':
      show_chains(ch == 'C');
      break;
   case 'e':
      show_readers();
      break;
   case 'f':
      show_flow_table();
      break;
   case 'h':
      show_flow_hash();
      break;
   case 'H':
      show_stream_hash(1);
      break;
   case 'm':
      show_memory();
      break;
   case 'p':
      show_protocols();
      break;
   case 'u':
      show_rulesets();
      break;
   case 's':
      show_stats();
      break;
   case 't':
      show_meter_time();
      break;
#if PM_DEBUG
   case '\\':
      printf("pm_debug: ");
#ifdef DOS
      c = getch();
#else
      c = getchar();
#endif
      if (c == '\\') {
         pm_dbg = 0;
         printf("ri[] off");
         }
      else {
         c -= '0';
         pm_dbg = c == 0 ? 10 : c;
         printf("ri[%d]", pm_dbg);
         }
      break;
#endif
   case 'z':
      zero_stats(1);
      break;
   case '?':
      show_help();
      break;
   default:
      break;
      }
   }
